/* 
(c) 2004-2007 U.S. Robotics Corporation

THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF ANY
KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S. Robotics
SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
*/

/* check settings for the LAN page */
function checkIP()
{
	var radios = document.idForm.idIPmethod;
	
	if (radios[1].checked) 
		document.idForm.lan_dhcp.value = "0";
}


/* --------------------------------------------------------------------------

	Bridge functions

	Assumptions:
		Channel index 0 is "1"
		"No security" option is called "None"
*/
function Site(strSSID, strMAC, iChannel, iSignal, bSecure, bIBSS, bWDS, strCtrlsb, iNBW)
{
	this.strSSID = strSSID;
	this.strMAC = strMAC;
	this.iChannel = iChannel;
	this.iSignal = iSignal;
	this.bSecure = bSecure;
	this.bIBSS = bIBSS;
	this.bWDS = bWDS;
	this.strCtrlsb = strCtrlsb;
	this.iNBW = iNBW;
}

function buildSiteSurveyTable(sites, ix)
{	
	var div = document.getElementById("idSurvey");
	if (div == null)
		return;
	
	if ((sites.length == 0) && document.idForm.chkInList != null)
	{
		div.innerHTML = "";
		return;
	}
	
	var wds = false;
	var infra = false;
	var flag = false;
	var page = document.idForm.page.value;
	var mode1 = document.getElementById("optInfra");
	var mode2 = document.getElementById("optWDS");
	var mode3 = document.getElementById("optRepeater");
	//var mode4 = document.getElementById("optAP");
	
	if (document.idForm.chkInList == null) {
		if (mode1.checked)
			infra = true;
		else if ((mode2.checked) || (mode3.checked))
			wds = true;
	}
	/*
	else if (page == "setup_infra.asp")
		infra = true;
	else if ((page == "setup_wds.asp") || (page == "setup_repeater.asp"))
		wds = true;
	*/		
	/*
		Note: If there is no "In list?" check box on the page, we put the
				manual fields in the table itself--not in a separate DIV.
	*/
	var strTable = "";
	
	strTable += "<table class=\"clsRuled\" border=\"0\" cellpadding=\"2\" cellspacing=\"2\">";

	strTable += "	<colgroup>";
	strTable += "		<col span=\"3\" class=\"clsColumnShaded\">";
	strTable += "		<col span=\"2\">";
	strTable += "	<\/colgroup>";

	strTable += "	<thead><tr align=\"left\">";
	strTable += "		<th colspan=\"2\"><label>Network Name<\/label><\/th>";
	if (wds)
		strTable += "		<th><label>WDS<\/label><\/th>";
	strTable += "		<th><label>Strength<\/label><\/th>";
	strTable += "		<th><label>Wireless MAC Address<\/label><\/th>";
	strTable += "		<th><label>Channel<\/label><\/th>";
	strTable += "	<\/tr><\/thead>";
	
	if (sites.length > 0) 
	{
		for (var i in sites)
		{
			if (infra  && !sites[i].bIBSS)
			{
				strTable += "<tr>\n";
				strTable += "<td><input type=\"radio\" name=\"rbAPs\" id=\"" + sites[i].strSSID + "\" value=\"" + sites[i].strSSID + "\" onclick=\"arrangeSiteSurvey(bSecure);\">" +
								" <label for=\"" + sites[i].strSSID + "\">" + convertFromHTML1(sites[i].strSSID) + "<\/label><\/td>\n";
				strTable += "<td align=\"center\">" + (sites[i].bSecure ? "<img src=\"lock.gif\" border=\"0\" \/>" : "&nbsp;") + "<\/td>\n";
				strTable += "<td align=\"center\"><span class=\"clsNote\">" + sites[i].iSignal + "%<\/span><\/td>\n";
				strTable += "<td><span class=\"clsNote\">" + sites[i].strMAC + "<\/span><\/td>\n";
				strTable += "<td align=\"center\">" + sites[i].iChannel + "<\/td>\n";
				strTable += "<\/tr>\n";
			}
			else if (wds)
			{
				strTable += "<tr>\n";
				strTable += "<td><input type=\"radio\" name=\"rbAPs\" id=\"" + sites[i].strMAC + "\" value=\"" + sites[i].strMAC + "\" onclick=\"arrangeSiteSurvey1(bSecure);\">" +
								" <label for=\"" + sites[i].strMAC + "\">" + convertFromHTML1(sites[i].strSSID) + "<\/label><\/td>\n";
				strTable += "<td align=\"center\">" + (sites[i].bSecure ? "<img src=\"lock.gif\" border=\"0\" \/>" : "&nbsp;") + "<\/td>\n";
				strTable += "<td align=\"center\">" + (sites[i].bWDS ? "<img src=\"check.gif\" border=\"0\" \/>" : "?") + "<\/td>\n";
				strTable += "<td align=\"center\"><span class=\"clsNote\">" + sites[i].iSignal + "%<\/span><\/td>\n";
				strTable += "<td><span class=\"clsNote\">" + sites[i].strMAC + "<\/span><\/td>\n";
				strTable += "<td align=\"center\">" + sites[i].iChannel + "<\/td>\n";
				strTable += "<\/tr>\n";
			}
		}
	}
	
	if (document.idForm.chkInList == null)
	{	
		flag = true;
		strTable += "<tr>\n";
		if (wds) {
			strTable += "<td><input type=\"radio\" name=\"rbAPs\" id=\"other\" value=\"other\" onclick=\"arrangeSiteSurvey1(bSecure);\">" +
					"<input type=\"text\" size=\"20\" maxlength=\"32\" name=\"wl_ssid_other\" id=\"txtSSID\" class=\"clsTextfield\" value=\"USR5454\" onchange=\"if (!isPrintable('Network name', document.idForm.wl_ssid_other)) return false; bDirty = true;\"><\/td>\n";
		}
		else {
			strTable += "<td><input type=\"radio\" name=\"rbAPs\" id=\"other\" value=\"other\" onclick=\"arrangeSiteSurvey(bSecure);\">" +
					"<input type=\"text\" size=\"20\" maxlength=\"32\" name=\"wl_ssid_other\" id=\"txtSSID\" class=\"clsTextfield\" value=\"USR5454\" onchange=\"if (!isPrintable('Network name', document.idForm.wl_ssid_other)) return false; bDirty = true;\"><\/td>\n";
		}
		strTable += "<td>&nbsp;<\/td>\n";
		if (wds)
			strTable += "<td align=\"center\">?<\/td>\n";
		strTable += "<td align=\"center\">&mdash;<\/td>\n";
		if (wds)
			strTable += "<td><input type=\"text\" size=\"20\" maxlength=\"17\" name=\"txtMACaddressAP\" id=\"txtMACaddressAP\" class=\"clsTextfield\" onchange=\"validateMAC(document.idForm.txtMACaddressAP.value); bDirty = true;\">";
		else
			strTable += "<td align=\"center\">&mdash;<\/td>\n";
		strTable += "<td>";
		strTable += "<select name=\"wl_channel_other\" id=\"cbChannel\" onchange=\"bDirty = true;\">";
		strTable += "<option value=\"1\">1<\/option>";
		strTable += "<option value=\"2\">2<\/option>";
		strTable += "<option value=\"3\">3<\/option>";
		strTable += "<option value=\"4\">4<\/option>";
		strTable += "<option value=\"5\">5<\/option>";
		strTable += "<option value=\"6\">6<\/option>";
		strTable += "<option value=\"7\">7<\/option>";
		strTable += "<option value=\"8\">8<\/option>";
		strTable += "<option value=\"9\">9<\/option>";
		strTable += "<option value=\"10\">10<\/option>";
		strTable += "<option value=\"11\">11<\/option>";
		/*
			If this isn't US-based, allow channels 12 and 13.
		*/
		if (ix == "IT")
		{
			strTable += "<option value=\"12\">12<\/option>\n";
			strTable += "<option value=\"13\">13<\/option>\n";
		}
		strTable += "<\/select>";
		strTable += "<\/td>\n";
		strTable += "<\/tr>\n";
	}
	strTable += "	<\/table>";

	div.innerHTML = strTable;
	if (flag) {
		//getRB(document.idForm.rbAPs, 0).focus();
		getRB(document.idForm.rbAPs, 0).checked = true;
	}
}

/*
	This function returns the value of the selected site's radio button,
	which is its SSID. This can be used to retrieve its
	associated Site object.
*/
function getSelectedSite()
{
	if (document.idForm.rbAPs == null)
		return null;
					
	for (var i = 0; i < getRBlength(document.idForm.rbAPs); ++i)
	{
		if (getRB(document.idForm.rbAPs, i).checked)
			return convertFromHTML(getRB(document.idForm.rbAPs, i).value);
	}
	return null;
}

/*
	This function returns the radio button with the passed index.
	It returns null if there's no match.
*/
function findSiteInRadios(strSSID)
{	
	if (document.idForm.rbAPs == null)
		return;
	
	for (var i = 0; i < getRBlength(document.idForm.rbAPs); ++i)
	{
		if (convertFromHTML(getRB(document.idForm.rbAPs, i).value) == convertFromHTML(strSSID))
			return getRB(document.idForm.rbAPs, i);
	}
	return null;
}

/*
	This function returns the Site object with the passed SSID.
*/
// can't use a dictionary
function findSite(strSSID)
{
	for (var i in sites)
	{
		if (convertFromHTML(sites[i].strSSID) == convertFromHTML(strSSID))
			return sites[i];
	}
	return null;
}


function setVisibilityByCheckbox(idCheck, idSame, idOpposite)
{
	var eltCheck = document.getElementById(idCheck);
	if ((eltCheck == null) || !eltCheck.style || (eltCheck.style.display == null))
		return;

	if (idSame != "")
		setVisibility(idSame, eltCheck.checked);
	if (idOpposite != "")
		setVisibility(idOpposite, !eltCheck.checked);
}


function initializeSurveyPage(strSSID, channel, bSecure)
{
	var mode1 = document.getElementById("optInfra");
	var page = document.idForm.page.value;
	
	/*if the scan list is empty */
	if ((sites.length == 0) || (document.idForm.rbAPs == null))
	{
		setVisibility("idNoAPs", true);
		setVisibility("idFoundAPs", false);
		if (document.idForm.chkInList == null)
			document.idForm.txtSSID.value = convertFromHTML(strSSID);
		arrangeSiteSurvey(bSecure);
		return;
	}
		
	setVisibility("idNoAPs", false);
	setVisibility("idFoundAPs", true);
		
	var rb = null;
	// if nothing's passed, select the first one in the list
	if (strSSID == "")
		rb = getRB(document.idForm.rbAPs, 0);
	else
		rb = findSiteInRadios(strSSID);

	// if the site's not in the survey, enter the information manually
	if (rb == null)
	{
		if (document.idForm.chkInList == null) {
			if (document.idForm.rbAPs.length == null)
				; //document.idForm.rbAPs[1].checked = true;
			else
				document.idForm.rbAPs[document.idForm.rbAPs.length - 1].checked = true;
			if (mode1.checked) {
				if (channel == 0)
					channel = 1;
				document.idForm.cbChannel[channel - 1].selected = true;
			}
		}
		else {
			document.idForm.chkInList.checked = false;
		}
		document.idForm.txtSSID.value = convertFromHTML(strSSID);
	}
	else
	{
		rb.checked = true;
		rb.focus();
	}

	arrangeSiteSurvey(bSecure);
}

function arrangeSiteSurvey(bSecure)
{
	var chkInList = document.getElementById("chkInList");
	var nmode = document.idForm.wl_nmode.value;
		
	setVisibilityByCheckbox("chkInList", "idBroadcast", "idNotBroadcast");
	setVisibilityByCheckbox("chkInList", "idSiteSurvey", "idMan");

	// if the selected AP is a known AP (i.e., in the list)...
	if (sites.length > 0)
	{
		if ((chkInList == null) || (chkInList.checked))  
		{
			// The selected AP's SSID, MAC address, and channel number should be retrieved from the site survey data.
			var strSSID = getSelectedSite();
			var site = findSite(strSSID);
			if (site == null)
			{	//if wireless page and no match in the list
				if (chkInList == null)
				{	/* enable the Manual Security section */
					setVisibility("idInsecure", false);
					setVisibility("idSecure", false);
					setVisibility("idManual", true);
					setVisibility("idSecurity", bSecure);
					document.idForm.chkSecure.checked = bSecure;	// default to secure network
				}
				onSecurityChange(false, 3);
				return;
			}
			// is it secure?
			setVisibility("idInsecure", !site.bSecure);
			setVisibility("idSecure", site.bSecure);
			setVisibility("idManual", false);
			setVisibility("idSecurity", site.bSecure);
			document.idForm.chkSecure.checked = site.bSecure;	// set checkbox for backend
		
			//set wl_nctrlsb and wl_nbw
			if (site.iNBW == 40) {
				document.idForm.wl_nbw_cap.selectedIndex = 1;
				if (nmode == -1)
					document.idForm.wl_nctrlsb.disabled = 0;
				if (site.strCtrlsb == "upper")
					document.idForm.wl_nctrlsb.selectedIndex = 1;
				else 
					document.idForm.wl_nctrlsb.selectedIndex = 0;
			}
			else {
				document.idForm.wl_nbw_cap.selectedIndex = 0;
				document.idForm.wl_nctrlsb.selectedIndex = 0;
				document.idForm.wl_nctrlsb.disabled = 1;
			}
		}
		else	//setup_sec.asp page
		{	/* enable the Manual Security section */
			setVisibility("idInsecure", false);
			setVisibility("idSecure", false);
			setVisibility("idManual", true);
			setVisibility("idSecurity", true);

			document.idForm.chkSecure.checked = true;	// default to secure network
			setVisibilityByCheckbox("chkSecure", "idSecurity", "");
		}
	}
	else	//no AP in the list
	{	//wireless page and no AP in the list
		if (chkInList == null)
		{	/* enable Security section */
			setVisibility("idInsecure", false);
			setVisibility("idSecure", false);
			setVisibility("idManual", true);
			setVisibility("idSecurity", bSecure);
			document.idForm.chkSecure.checked = bSecure;	// default to secure network
		}
		else	//setup_sec.asp page
		{	/* enable the Manual Security section */
			setVisibility("idInsecure", false);
			setVisibility("idSecure", false);
			setVisibility("idManual", true);
			setVisibility("idSecurity", true);
			document.idForm.chkSecure.checked = true;	// default to secure network
			setVisibilityByCheckbox("chkSecure", "idSecurity", "");
		}
	}

	//document.idForm.cbSecurity.selectedIndex = 0;
	onSecurityChange(false, 3);
}

/* --------------------------------------------------------------------------

	WDS Bridge functions

	Assumptions:
		Channel index 0 is "1"
		"No security" option is called "None"
*/

/*
	This function returns the Site object with the passed MAC address.
*/
// can't use a dictionary
function findSite1(strMAC)
{
	for (var i in sites)
	{
		if (sites[i].strMAC == strMAC)
			return sites[i];
	}
	return null;
}

function initializeSurveyPage1(strMAC, strSSID, channel, bSecure)
{
	if (sites.length == 0)
	{
		setVisibility("idNoAPs", true);
		setVisibility("idFoundAPs", false);
		if (document.idForm.chkInList == null)
		{	
			document.idForm.txtMACaddressAP.value = strMAC;
			document.idForm.txtSSID.value = convertFromHTML(strSSID);
			if (channel == 0)
				channel = 1;
			document.idForm.cbChannel[channel - 1].selected = true;
		}
		arrangeSiteSurvey1(bSecure);
		return;
	}

	setVisibility("idNoAPs", false);
	setVisibility("idFoundAPs", true);
		
	var rb = null;
	// if nothing's passed, select the first one in the list
	if (strMAC == "")
		rb = getRB(document.idForm.rbAPs, 0);
	else
		rb = findSiteInRadios(strMAC);

	// if the site's not in the survey, enter the information manually
	if (rb == null)
	{
		if (document.idForm.chkInList == null)
			document.idForm.rbAPs[document.idForm.rbAPs.length - 1].checked = true;
		else
			document.idForm.chkInList.checked = false;
		document.idForm.txtMACaddressAP.value = strMAC;
		document.idForm.txtSSID.value = convertFromHTML(strSSID);
		if (channel == 0)
			channel = 1;
		document.idForm.cbChannel[channel - 1].selected = true;
	}
	else
	{
		rb.checked = true;
		rb.focus();
	}

	arrangeSiteSurvey1(bSecure);
}

function arrangeSiteSurvey1(bSecure)
{
	var chkInList = document.getElementById("chkInList");
	var mode = document.getElementById("optRepeater");
	var nmode = document.idForm.wl_nmode.value;
		
	setVisibilityByCheckbox("chkInList", "idBroadcast", "idNotBroadcast");
	setVisibilityByCheckbox("chkInList", "idSiteSurvey", "idMan");

	// if the selected AP is a known AP (i.e., in the list)...
	if (sites.length > 0)
	{
		if ((chkInList == null) || (chkInList.checked))  
		{
			// The selected AP's SSID, MAC address, and channel number should be retrieved from the site survey data.
			var strMAC = getSelectedSite();
			var site = findSite1(strMAC);
			if (site == null)
			{	//if wireless page and no match in the list
				if (chkInList == null)
				{	/* enable the Manual Security section */
					setVisibility("idInsecure", false);
					setVisibility("idSecure", false);
					setVisibility("idManual", true);
					setVisibility("idSecurity", bSecure);
					document.idForm.chkSecure.checked = bSecure;	// default to secure network
				}
				if (mode.checked)
					onSecurityChange(false, 1);
				else
					onSecurityChange(false, 4);
				return;
			}
			// is it secure?
			setVisibility("idInsecure", !site.bSecure);
			setVisibility("idSecure", site.bSecure);
			setVisibility("idManual", false);
			setVisibility("idSecurity", site.bSecure);
			document.idForm.chkSecure.checked = site.bSecure;	// set checkbox for backend
		}
		else	//setup_sec.asp page
		{	/* enable the Manual Security section */
			setVisibility("idInsecure", false);
			setVisibility("idSecure", false);
			setVisibility("idManual", true);
			setVisibility("idSecurity", true);

			document.idForm.chkSecure.checked = true;	// default to secure network
			setVisibilityByCheckbox("chkSecure", "idSecurity", "");
		}
		//set wl_nctrlsb and wl_nbw
		if (site.iNBW == 40) {
			document.idForm.wl_nbw_cap.selectedIndex = 1;
			if (nmode == -1)
				document.idForm.wl_nctrlsb.disabled = 0;
			if (site.strCtrlsb == "upper")
				document.idForm.wl_nctrlsb.selectedIndex = 1;
			else 
				document.idForm.wl_nctrlsb.selectedIndex = 0;
		}
		else {
			document.idForm.wl_nbw_cap.selectedIndex = 0;
			document.idForm.wl_nctrlsb.selectedIndex = 0;
			document.idForm.wl_nctrlsb.disabled = 1;
		}
	}
	else	//no AP in the list
	{	//wireless page and no AP in the list
		if (chkInList == null)
		{	/* enable Security section */
			setVisibility("idInsecure", false);
			setVisibility("idSecure", false);
			setVisibility("idManual", true);
			setVisibility("idSecurity", bSecure);
			document.idForm.chkSecure.checked = bSecure;	// default to secure network
		}
		else	//setup_sec.asp page
		{	/* enable the Manual Security section */
			setVisibility("idInsecure", false);
			setVisibility("idSecure", false);
			setVisibility("idManual", true);
			setVisibility("idSecurity", true);
			document.idForm.chkSecure.checked = true;	// default to secure network
			setVisibilityByCheckbox("chkSecure", "idSecurity", "");
		}
	}

	if (mode.checked)
		onSecurityChange(false, 1);
	else
		onSecurityChange(false, 4);
}

/* --------------------------------------------------------------------------

	Device management functions

*/

/*
	This global variable and function prevent an IE user from accidentally
	leaving a page without saving their changes.
*/
var bDirty = false;

function verifyDeparture()
{
	if (bDirty)
		event.returnValue = "You have made changes to this page. If you leave the page without saving them, your changes will be lost.";
}

function reloadDevice()
{
	return confirm("If you want to restore the device to the original factory settings, press OK. Press Cancel to do nothing.");
}

/* --------------------------------------------------------------------------

   General helper functions

*/
/*
	If a radio button array has only one button, it's NOT an array,
	and we can't access it as such. To work around that, we have
	this little access function for radio buttons.
	Typically, this won't be necessary because radio buttons
	should always have two or more, but the site survey is special.
*/
function getRBlength(elt)
{		
	if (document.idForm.rbAPs == null)
		return null;
	if (document.idForm.rbAPs.length == undefined)
		return 1;
	else
		return elt.length;
}

function getRB(elt, ix)
{
	if (document.idForm.rbAPs == null)
		return null;
	if (document.idForm.rbAPs.length == undefined)
		return elt;
	else
		return elt[ix];
}

/*
	This function determines if the passed key is the correct length
	for the passed key type (# of bits and ASCII/hex).
*/
function validateKeyForType(key, idType)
{
	var eltType = document.getElementById(idType);
	if ((eltType == null) || !eltType.style || (eltType.style.display == null))
		return;

	// determine # of bits
	var bits = 64;
	if ((eltType.selectedIndex == 0) || (eltType.selectedIndex == 1))
		bits = 128;

	// ASCII or hex key
	var bHex = true;
	if ((eltType.selectedIndex == 0) || (eltType.selectedIndex == 2))
		bHex = false;

	if (key.length != getKeyLength(bits, bHex))
		return alert("The length of the key is incorrect. A 128-bit key must be 13 characters long in ASCII or 26 characters long in hexadecimal. A 64-bit key must be 5 characters long in ASCII or 10 characters long in hexadecimal."); 
	
	if (bHex) {
		if (!isHex(key)) {
			return alert("The key contains non-hexadecimal characters. A hexadecimal character is part of the following character set: 0-9, a-f or A-F."); 
			return false;
		}
	}
	return true;	
}

/* --------------------------------------------------------------------------

	These functions are a quick way to implement the same things
	on more than one Web page (typically setup*.htm and something else).

*/

function copySSIDandMAC()
{
	// The selected AP's MAC address should be retrieved from the site survey data.
	document.idForm.txtMACaddress.value = document.idForm.cbSurvey.options[document.idForm.cbSurvey.selectedIndex].value;
}


/* --------------------------------------------------------------------------

	These functions are a quick way to implement the same things
	on more than one Web page (typically setup*.htm and something else).

*/

/*
	This is the mapping of the Method combobox to the 802.1x choices.
*/
function is8021xselected(ix)
{
	return ((ix >= 5) && (ix <= 7));
}

/*
	This is the mapping of the Method combobox to the WPA choices.
*/
function isWPAselected(ix, change)
{
	if ((change == 0) || (change == 1))      //security.asp + ap
		return ((ix >= 0) && (ix <= 2));
	else if (change == 3) 	//client mode wireless.asp
		return ((ix >= 0) && (ix <= 1));
	else //change = 1 (security.asp + wds) or change = 2 (security_sec.asp)
		return ((ix == 0));
}

/*
	This is the mapping of the Method combobox to the WEP choices.
*/
function isWEPselected(ix, change)
{
	if ((change == 0) || (change == 1))     //security.asp + ap
		return ((ix >= 3) && (ix <= 4));
	else if (change == 3)     //client mode - wireless.asp
		return ((ix >= 2) && (ix <= 3));
	else  //change = 1 (security.asp + wds) or change = 2 (security_sec.asp)
		return ((ix >= 1) && (ix <= 2));
}

/*
	This is the mapping of the Method combobox to the WPA2 choices.
*/
function isWPA2selected(ix, change)
{
	if (change == 0)   //security.asp + ap
		return (((ix >= 0) && (ix <= 1)) || ((ix >= 5) && (ix <= 6)));
	else if (change == 1)   //security.asp + repeater
		return ((ix >= 0) && (ix <= 1));
	else 
		return ((ix == 0));
}

/*
	This is called when the user changes a sub-type of
	encryption (WEP ASCII 128-bit, WEP hex 64-bit, ...).
*/
function setMaxLength(bClearValues, change)
{
	if (change == 2)    //if setup_sec.asp
		var ixSecurity = document.idForm.cbAuthEncrypt.selectedIndex;
	else		   //if wireless.asp
		var ixSecurity = document.idForm.cbSecurity.selectedIndex;
	// WEP
	if (isWEPselected(ixSecurity, change))
	{
		/*
			128-bit ASCII
			128-bit hex
			64-bit ASCII
			64-bit hex
		*/
		var bHex = (document.idForm.cbWEPkeytype[1].selected || document.idForm.cbWEPkeytype[3].selected);

		var iBits = 128;
		if (document.idForm.cbWEPkeytype[2].selected || document.idForm.cbWEPkeytype[3].selected)
			iBits = 64;

		var iMaxLength = getKeyLength(iBits, bHex);
		document.getElementById("idKeyNumChars").innerHTML = iMaxLength;
		
		document.idForm.wl_key1.maxLength = iMaxLength;
		if (document.idForm.wl_key2 != null)
		{
			document.idForm.wl_key2.maxLength = iMaxLength;
			document.idForm.wl_key3.maxLength = iMaxLength;
			document.idForm.wl_key4.maxLength = iMaxLength;
		}
		
		if (bClearValues)
		{
			document.idForm.wl_key1.value = "";
			if (document.idForm.wl_key2 != null)
			{
				document.idForm.wl_key2.value = "";
				document.idForm.wl_key3.value = "";
				document.idForm.wl_key4.value = "";
			}
		}
	}
}

/*
	This is called when the user changes the main type of
	encryption (none, WEP, WPA).
*/
function onSecurityChange(bClearValues, change)
{
	if (change == 2)    //if setup_sec.asp
		var ixSecurity = document.idForm.cbAuthEncrypt.selectedIndex;
	else		   //if wireless.asp
		var ixSecurity = document.idForm.cbSecurity.selectedIndex;
			
	// if it's WEP, show the WEP properties
	var bWEP = isWEPselected(ixSecurity, change);
	setVisibility('idWEPkeytype',	bWEP);
	setVisibility('idKey1',		bWEP);
	if (change != 2)
	{	
		setVisibility('idKey2',		bWEP);
		setVisibility('idKey3',		bWEP);
		setVisibility('idKey4',		bWEP);
		setVisibility('idKeyCurrent',	bWEP);
	}
	setVisibility('idKeytxt',		bWEP);
		
	// if it's WPA, show WPA properties
	var bWPA = isWPAselected(ixSecurity, change);
	setVisibility('idPassPhrase',	bWPA);
	
	// if it's 802.1x, show 802.1x properties
	var b8021x = is8021xselected(ixSecurity);
	setVisibility('idRADIUSserver',	b8021x);
	setVisibility('idRADIUSport',	b8021x);
	setVisibility('idRADIUSkey',	b8021x);
	setVisibility('idRADIUSReauth',	b8021x);
	// if it's WPA2 and 802.1x, show Pre-authentication
	setVisibility('idRADIUSPreauth',b8021x && isWPA2selected(ixSecurity, change));
		
	if (change != 2) {
		setVisibility('idKeyRotation',	bWPA || b8021x);
		// if it's WPA-PSK or WPA/802.1x, show Encryption
		setVisibility('idEncryption',	bWPA || b8021x);
	}
	
	setMaxLength(bClearValues, change);
}


/*
   If the user selects "802.11b only," remove any supported rate
   over 11Mbps. If the user selects another setting, restore those
   rates.
*/
function manageSupportedRates()
{
   // if the user selected "802.11b only"
   if (document.idForm.cbMode.selectedIndex == 2)
   {
		document.idForm.cbSupportedRate.options.length = 7;
		document.idForm.cbMRate.options.length = 7;
   }
   else
   {
      // if there aren't enough rates, add them
      if (document.idForm.cbSupportedRate.options.length < 13)
      {
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("12 Mbps", "rate12");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("18 Mbps", "rate18");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("24 Mbps", "rate24");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("36 Mbps", "rate36");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("48 Mbps", "rate48");
         document.idForm.cbSupportedRate.options[document.idForm.cbSupportedRate.options.length] = new Option("54 Mbps", "rate54");
      }
      if (document.idForm.cbMRate.options.length < 13)
      {
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("12 Mbps", "rate12");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("18 Mbps", "rate18");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("24 Mbps", "rate24");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("36 Mbps", "rate36");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("48 Mbps", "rate48");
         document.idForm.cbMRate.options[document.idForm.cbMRate.options.length] = new Option("54 Mbps", "rate54");
      }
   }
}


/* check settings for the wireless page */
function checksettings()
{
	if (document.idForm.chkWME != null) {
		if (document.idForm.chkWME.checked) 
			document.idForm.wl_wme.value="on";
			
	/*	if (document.idForm.wl_wme_ap_bk5.checked)
			document.idForm.wl_wme_ap_bk5.value="on";
		if (document.idForm.wl_wme_ap_be5.checked)
			document.idForm.wl_wme_ap_be5.value="on";
		if (document.idForm.wl_wme_ap_vi5.checked)
			document.idForm.wl_wme_ap_vi5.value="on";
		if (document.idForm.wl_wme_ap_vo5.checked)
			document.idForm.wl_wme_ap_vo5.value="on";
		
		if (document.idForm.wl_wme_sta_bk5.checked)
			document.idForm.wl_wme_sta_bk5.value="on";	
		if (document.idForm.wl_wme_sta_be5.checked)
			document.idForm.wl_wme_sta_be5.value="on";
		if (document.idForm.wl_wme_sta_vi5.checked)
			document.idForm.wl_wme_sta_vi5.value="on";
		if (document.idForm.wl_wme_sta_vo5.checked)
			document.idForm.wl_wme_sta_vo5.value="on";
	*/
	}
	if (document.idForm.chkMcst != null) {
		if (document.idForm.chkMcst.checked) 
			document.idForm.wl_multicast.value="on";
	}
	
	var mode1 = document.getElementById("optWDS");
	var mode2 = document.getElementById("optRepeater");
	var mode = document.getElementById("optAP");
	// The selected AP's SSID, MAC address, and channel number should be retrieved from the site survey data.
	if (!mode.checked) {
		var strMAC = getSelectedSite();
		if (strMAC != null)
		{
			if (mode1.checked || mode2.checked)
				var site = findSite1(strMAC);	
			else
				var site = findSite(strMAC);
			if (site != null) {
				document.idForm.wl_ssid_other.value=convertFromHTML(site.strSSID);
				document.idForm.wl_channel_other.value=site.iChannel;
			}
		}
	}
}

/* check settings for the setup_wds, setup_repeater and setup_infra page */
function checksettings1()
{
	// The selected AP's SSID, MAC address, and channel number should be retrieved from the site survey data.
	var strMAC = getSelectedSite();
	if (strMAC != null)
	{
		if (document.idForm.wl_mode.value == "wet")
			var site = findSite(strMAC);
		else
			var site = findSite1(strMAC);	
		if ((site != null) && (document.idForm.chkInList.checked)) {
			document.idForm.wl_ssid.value=convertFromHTML(site.strSSID);
			document.idForm.wl_channel.value=site.iChannel;
		}
	}
}

/* check settings for the LAN page */
function checkDHCP()
{
	if (!document.idForm.chkDHCP.checked)
		document.idForm.lan_proto.value="static";	
}

/* compute new lan_lease value for lan.asp*/
function new_lease(s)
{
	var day = document.idForm.txtLeaseDays.value;
	var hour = document.idForm.txtLeaseHours.value;
	var minutes = document.idForm.txtLeaseMinutes.value;
		
	var lan_lease = day*86400 + hour*3600 + minutes*60;
	if ((lan_lease == 0) || (lan_lease > 604800)) {
		alert("Please enter a lease time greater than zero and less than seven days.");
		if (s)
			return false;
	}
	else {
		document.idForm.lan_lease.value = lan_lease;
		return true;
	}
}

/* compute new wl_net_reauth value for security.asp*/
function new_reauth()
{
	var minutes = document.idForm.wl_net_reauth.value;
	var seconds = minutes*60;
	
	document.idForm.wl_net_reauth.value = seconds;
}

function inet_aton(a)
{
	var n;

	n = a.split(/\./);
	if (n.length != 4)
		return 0;

	return ((n[0] << 24) | (n[1] << 16) | (n[2] << 8) | n[3]);
}

function inet_ntoa(n)
{
	var a;

	a = (n >> 24) & 255;
	a += "."
	a += (n >> 16) & 255;
	a += "."
	a += (n >> 8) & 255;
	a += "."
	a += n & 255;

	return a;
}

function lan_ipaddr_change()
{
	var lan_netaddr, lan_netmask, dhcp_start, dhcp_end;

	lan_netaddr = inet_aton(document.idForm.lan_ipaddr.value);
	lan_netmask = inet_aton(document.idForm.lan_netmask.value);
	lan_netaddr &= lan_netmask;

	dhcp_start = inet_aton(document.idForm.dhcp_start.value);
	dhcp_start &= ~lan_netmask;
	dhcp_start |= lan_netaddr;
	dhcp_end = inet_aton(document.idForm.dhcp_end.value);
	dhcp_end &= ~lan_netmask;
	dhcp_end |= lan_netaddr;

	document.idForm.dhcp_start.value = inet_ntoa(dhcp_start);
	document.idForm.dhcp_end.value = inet_ntoa(dhcp_end);
}

/* --------------------------------------------------------------------------

	"List of entries" functions

	These functions use the passed "table object" to manipulate the entries
	in a device table.

*/

/*
	This function writes the table of entries represented by the passed object.
*/
function tableDisplay(objTable)
{
	/*
		Construct the table code
	*/
	var inside = "";

	// create hidden field with required form variable name for # of entries
	inside += "<input type=\"hidden\" name=\"" + objTable.strVarNameNum + "\" value=\"" + objTable.aRows.length + "\">";


	// if there are no rows, don't display the table at all
	if (objTable.aRows.length > 0)
	{
		inside += "<table class=\"clsRuled\">";

		/*
			Output the headings
		*/
		inside += "<thead><tr valign=\"bottom\">";
		// Add each column heading
		for (var col in objTable.aHeadings)
		{
			inside += "<th align=\"left\">";
			inside += objTable.aHeadings[col];
			inside += "<\/th>";
		}
		inside += "<th><\/th>";			// empty header cell for Delete button
		inside += "<\/tr><\/thead>";

		inside += "<tbody>";

		/*
			For each row of values, build that row.
		*/
		for (var row in objTable.aRows)
			inside += objTable.fctFormatRow(objTable, row);

		inside += "<\/tbody><\/table>";
	}

	objTable.eltTable.innerHTML = inside;

	// if we have the max # of rows in the table, disable Add button
	objTable.eltBtnAdd.disabled = (objTable.aRows.length == objTable.iMaxNumRows);
}


/*
	This function returns the HTML for the passed row of the table.
	It is the default "custom" formatting function, assuming that every
	column merely has text. Other, more complicated, tables can use
	their own custom formatting function to do more complicated things.

	Arguments:
			objTable 	table object
			row		index of row being formatted

	Returns:	HTML markup for this row
			<tr>...</tr>
*/
function fctFormatRowText(objTable, row)
{
	var strHTML = "<tr>";

	/*
		For each column in each of the column arrays, add to this row.
	*/
	var aRow = objTable.aRows[row];
	for (var col in aRow)
	{
		strHTML += "<td class=\"clsEntry\">";
		strHTML += aRow[col];

		// create hidden field with required form variable name
		strHTML += "<input type=\"hidden\" name=\"" + objTable.aVarNamePrefixes[col] + row + "\" value=\"" + aRow[col] + "\">";

		strHTML += "<\/td>";
	}
	strHTML += "<td>";
	strHTML += "<input type=\"button\" value=\"Delete\" class=\"clsSmall\" onclick=\"tableDeleteRow(" + objTable.strThis + ", " + row + ");\">";
	strHTML += "<\/td>";

	strHTML += "<\/tr>";

	return strHTML;
}


/*
	This function adds the passed row (array) to the table.
*/
function tableAddRow(objTable, aRowNew, x)
{
	if (x == 0)
		//add a new row in the table
		objTable.aRows.push(aRowNew);
	else if (x == 1) 
	{
		//overwrite first row in the table 
		objTable.aRows[0] = aRowNew;
	}
			
	tableDisplay(objTable);
	bDirty = true;
}


/*
	This function returns true if all values are not blank.
	It returns false if any value is blank.
	If a value is blank, it displays an error message specific to that column.

	This can be called by a table whose data are all text and require no
	special handling. It should be called before calling tableAddRow().
*/
function validateDataText(objTable, aRow)
{
	for (var col in aRow)
	{
		if (aRow[col] == "")
		{
			alert("Please enter a value for " + objTable.aHeadings[col] + ".");
			return false;
		}
	}

	return true;
}

/*
	This function returns true if the passed row is already in the passed
	table.
*/
function tableIsDuplicateRow(objTable, aRow)
{
	// compare passed row with each row in the table
	for (var i in objTable.aRows)
	{
		// compare each element in the passed row with each element in the current table row
		var bSame = true;
		for (var e in aRow)
		{
			if (aRow[e] != objTable.aRows[i][e])
			{
				bSame = false;
				break;
			}
		}
		if (bSame)
			return true;
	}
	return false;
}


/*
	This function deletes the specified row.
*/
function tableDeleteRow(objTable, ixRow)
{
	// BUG: This is a workaround for the above-mentioned IE bug.
	for (var i = ixRow; i < objTable.aRows.length; ++i)
		objTable.aRows[i] = objTable.aRows[i + 1];
	--objTable.aRows.length;

	tableDisplay(objTable);
	bDirty = true;
}


/*
	This function modifies a value in the specified column of the specified
	row. Right now, it only works for a checkbox, but it could be extended
	to work with any type of field.
*/
function tableModifyValue(objTable, row, col)
{
	objTable.aRows[row][col] = (objTable.aRows[row][col] == "on") ? "off" : "on";
	tableDisplay(objTable);
	bDirty = true;
}

/* if Acceleration is Afterburner - fragmentation field can't be changed */
function changeAcceleration()
{
	var ixAccel = document.idForm.cbAcceleration.selectedIndex;

	if (ixAccel == 2)
	{
		setEnabled("lblFrag", false);
		setEnabled("wl_frag", false);
		document.idForm.wl_frag.value = "2346";
	}
	else
	{
		setEnabled("lblFrag", true);
		setEnabled("wl_frag", true);
	}
}

/* setup encryption on the setup_sec.asp page */
function set_encryption()
{
	var ix = document.idForm.cbAuthEncrypt.selectedIndex;
	
	if (ix == 0)
		document.idForm.cbEncryption.value="tkip+aes";
	else	
		document.idForm.cbEncryption.value="none";
}

/* check settings for the firewall settings in firewall.asp */
function checklog()
{
	if (!document.idForm.chkSystemLog.checked)
		document.idForm.log_ipaddr.value="";
}

/*
	This function validates that the passed string is a valid format for
	rotation key interval. The format is an integer number, up to 5 digits
*/
function validateKey(elt)
{	
	var bOK = false;
	if (/^\d{1,5}$/.test(elt.value))
		bOK = true;
	if (!bOK) {
		alert("Please enter a valid key rotation.\n\nThe key rotation value has to be a number between 0 and 99,999.");
		elt.focus();
	}
	return bOK;
}

function convertFromHTML(s)
{
	/* this one has to go first because the others insert an
	   ampersand into the string */
       if (s == null)
       	return "";
       s = s.replace(/&amp;/g, "&");
       
       s = s.replace(/&lt;/g, "<");
       s = s.replace(/&gt;/g, ">");
       s = s.replace(/&quot;/g, '"');
       
       return s;
}

function convertFromHTML1(s)
{
	/* this one has to go first because the others insert an
	   ampersand into the string */
       if (s == null)
       	return "";
       s = s.replace(/&amp;/g, "&");
       s = s.replace(/&quot;/g, '"');
       
       return s;
}
